/**
 * COCTMT230100UVManufacturer.java
 *
 * File generated from the medication::COCTMT230100UVManufacturer uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class COCTMT230100UVManufacturer.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "COCT_MT230100UV.Manufacturer", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"name",
	"telecom",
	"addr",
	"asRelatedManufacturer",
	"classCode",
	"determinerCode",
	"nullFlavor"
})
@XmlRootElement(name = "COCT_MT230100UV.Manufacturer")
public class COCTMT230100UVManufacturer implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId;
	@XmlElement(name = "id", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.II id;
	@XmlElement(name = "name", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.EN name;
	@XmlElement(name = "telecom", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.TEL telecom;
	@XmlElement(name = "addr", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.AD addr;
	@XmlElement(name = "asRelatedManufacturer", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVRelatedManufacturer> asRelatedManufacturer;
	@XmlAttribute(name = "classCode", required = true)
	public net.ihe.gazelle.medication.EntityClassOrganization classCode;
	@XmlAttribute(name = "determinerCode", required = true)
	public net.ihe.gazelle.medication.EntityDeterminerSpecific determinerCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.medication.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.templateId.remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public net.ihe.gazelle.medication.II getId() {
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(net.ihe.gazelle.medication.II id) {
	    this.id = id;
	}
	
	
	
	
	/**
	 * Return name.
	 * @return name
	 */
	public net.ihe.gazelle.medication.EN getName() {
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(net.ihe.gazelle.medication.EN name) {
	    this.name = name;
	}
	
	
	
	
	/**
	 * Return telecom.
	 * @return telecom
	 */
	public net.ihe.gazelle.medication.TEL getTelecom() {
	    return telecom;
	}
	
	/**
	 * Set a value to attribute telecom.
	 * @param telecom.
	 */
	public void setTelecom(net.ihe.gazelle.medication.TEL telecom) {
	    this.telecom = telecom;
	}
	
	
	
	
	/**
	 * Return addr.
	 * @return addr
	 */
	public net.ihe.gazelle.medication.AD getAddr() {
	    return addr;
	}
	
	/**
	 * Set a value to attribute addr.
	 * @param addr.
	 */
	public void setAddr(net.ihe.gazelle.medication.AD addr) {
	    this.addr = addr;
	}
	
	
	
	
	/**
	 * Return asRelatedManufacturer.
	 * @return asRelatedManufacturer
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVRelatedManufacturer> getAsRelatedManufacturer() {
		if (asRelatedManufacturer == null) {
	        asRelatedManufacturer = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVRelatedManufacturer>();
	    }
	    return asRelatedManufacturer;
	}
	
	/**
	 * Set a value to attribute asRelatedManufacturer.
	 * @param asRelatedManufacturer.
	 */
	public void setAsRelatedManufacturer(List<net.ihe.gazelle.medication.COCTMT230100UVRelatedManufacturer> asRelatedManufacturer) {
	    this.asRelatedManufacturer = asRelatedManufacturer;
	}
	
	
	
	/**
	 * Add a asRelatedManufacturer to the asRelatedManufacturer collection.
	 * @param asRelatedManufacturer_elt Element to add.
	 */
	public void addAsRelatedManufacturer(net.ihe.gazelle.medication.COCTMT230100UVRelatedManufacturer asRelatedManufacturer_elt) {
	    this.asRelatedManufacturer.add(asRelatedManufacturer_elt);
	}
	
	/**
	 * Remove a asRelatedManufacturer to the asRelatedManufacturer collection.
	 * @param asRelatedManufacturer_elt Element to remove
	 */
	public void removeAsRelatedManufacturer(net.ihe.gazelle.medication.COCTMT230100UVRelatedManufacturer asRelatedManufacturer_elt) {
	    this.asRelatedManufacturer.remove(asRelatedManufacturer_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.medication.EntityClassOrganization getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.medication.EntityClassOrganization classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return determinerCode.
	 * @return determinerCode
	 */
	public net.ihe.gazelle.medication.EntityDeterminerSpecific getDeterminerCode() {
	    return determinerCode;
	}
	
	/**
	 * Set a value to attribute determinerCode.
	 * @param determinerCode.
	 */
	public void setDeterminerCode(net.ihe.gazelle.medication.EntityDeterminerSpecific determinerCode) {
	    this.determinerCode = determinerCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.medication.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.medication.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "COCT_MT230100UV.Manufacturer").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(COCTMT230100UVManufacturer cOCTMT230100UVManufacturer, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cOCTMT230100UVManufacturer != null){
   			cvm.validate(cOCTMT230100UVManufacturer, location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: cOCTMT230100UVManufacturer.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.infr.AllInfrastructureRootTypeId.validateByModule(cOCTMT230100UVManufacturer.getTypeId(), location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId: cOCTMT230100UVManufacturer.getTemplateId()){
					net.ihe.gazelle.infr.AllInfrastructureRootTemplateId.validateByModule(templateId, location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.II.validateByModule(cOCTMT230100UVManufacturer.getId(), location + "/id", cvm, diagnostic);
			net.ihe.gazelle.medication.EN.validateByModule(cOCTMT230100UVManufacturer.getName(), location + "/name", cvm, diagnostic);
			net.ihe.gazelle.medication.TEL.validateByModule(cOCTMT230100UVManufacturer.getTelecom(), location + "/telecom", cvm, diagnostic);
			net.ihe.gazelle.medication.AD.validateByModule(cOCTMT230100UVManufacturer.getAddr(), location + "/addr", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVRelatedManufacturer asRelatedManufacturer: cOCTMT230100UVManufacturer.getAsRelatedManufacturer()){
					net.ihe.gazelle.medication.COCTMT230100UVRelatedManufacturer.validateByModule(asRelatedManufacturer, location + "/asRelatedManufacturer[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}